gi-gdkx11-3.0.10: GdkX11 bindings

Copyright | Will Thompson Iñaki García Etxebarria and Jonas Platte
License | LGPL-2.1
Maintainer | Iñaki García Etxebarria
Safe Haskell | None
Language | Haskell2010

GI.GdkX11.Functions

Contents

- Methods
  - x11AtomToXatom
  - x11AtomToXatomForDisplay
  - x11DeviceGetId
  - x11DeviceManagerLookup
  - x11FreeCompoundText
  - x11FreeTextList
  - x11GetDefaultRootXwindow
  - x11GetDefaultScreen
  - x11GetDefaultXdisplay
  - x11GetParentRelativePattern
  - x11GetServerTime
  - x11GetXatomByName
  - x11GetXatomByNameForDisplay
  - x11GetXatomName
  - x11GetXatomNameForDisplay
  - x11GrabServer
  - x11LookupXdisplay
  - x11RegisterStandardEventType
  - x11SetSmClientId
  - x11UngrabServer
  - x11XatomToAtom
  - x11XatomToAtomForDisplay

Description

Synopsis

- x11AtomToXatom :: (HasCallStack, MonadIO m) => Atom -> m CULong
- x11AtomToXatomForDisplay :: (HasCallStack, MonadIO m, IsX11Display a) => a -> Atom -> m CULong
- x11DeviceGetId :: (HasCallStack, MonadIO m, IsX11DeviceCore a) => a -> m Int32
- x11DeviceManagerLookup :: (HasCallStack, MonadIO m, IsX11DeviceManagerCore a) => a -> Int32 -> m (Maybe X11DeviceCore)
- x11FreeCompoundText :: (HasCallStack, MonadIO m) => Word8 -> m ()
- x11FreeTextList :: (HasCallStack, MonadIO m) => Text -> m ()
- x11GetDefaultRootXwindow :: (HasCallStack, MonadIO m) => m CULong
- x11GetDefaultScreen :: (HasCallStack, MonadIO m) => m Int32
- x11GetDefaultXdisplay :: (HasCallStack, MonadIO m) => m Display
- x11GetParentRelativePattern :: (HasCallStack, MonadIO m) => m Pattern
- x11GetServerTime :: (HasCallStack, MonadIO m, IsX11Window a) => a -> m Word32
- x11GetXatomByName :: (HasCallStack, MonadIO m) => Text -> m CULong
- x11GetXatomByNameForDisplay :: (HasCallStack, MonadIO m, IsX11Display a) => a -> Text -> m CULong
- x11GetXatomName :: (HasCallStack, MonadIO m) => CULong -> m Text
- x11GetXatomNameForDisplay :: (HasCallStack, MonadIO m, IsX11Display a) => a -> CULong -> m Text
- x11GrabServer :: (HasCallStack, MonadIO m) => m ()
- x11LookupXdisplay :: (HasCallStack, MonadIO m) => Display -> m X11Display
- x11RegisterStandardEventType :: (HasCallStack, MonadIO m, IsX11Display a) => a -> Int32 -> Int32 -> m ()
- x11SetSmClientId :: (HasCallStack, MonadIO m) => Maybe Text -> m ()
- x11UngrabServer :: (HasCallStack, MonadIO m) => m ()
- x11XatomToAtom :: (HasCallStack, MonadIO m) => CULong -> m Atom
- x11XatomToAtomForDisplay :: (HasCallStack, MonadIO m, IsX11Display a) => a -> CULong -> m Atom

# Methods

## x11AtomToXatom

x11AtomToXatom Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Atom | `atom`: A `Atom`
-> m CULong | Returns: the X atom corresponding to `atom`.

Converts from a `Atom` to the X atom for the default GDK display with the same string value.

## x11AtomToXatomForDisplay

x11AtomToXatomForDisplay Source #

Arguments

:: (HasCallStack, MonadIO m, IsX11Display a) |
=> a | `display`: A `Display`
-> Atom | `atom`: A `Atom`, or `GDK_NONE`
-> m CULong | Returns: the X atom corresponding to `atom`, or `None`

Converts from a `Atom` to the X atom for a `Display` with the same string value. The special value `GDK_NONE` is converted to `None`.

Since: 2.2

## x11DeviceGetId

x11DeviceGetId Source #

Arguments

:: (HasCallStack, MonadIO m, IsX11DeviceCore a) |
=> a | `device`: a `Device`
-> m Int32 | Returns: the XInput2 device ID.

Returns the device ID as seen by XInput2.

    If 'GI.Gdk.Functions.disableMultidevice' has been called, this function
    will respectively return 2\/3 for the core pointer and keyboard,
    (matching the IDs for the Virtual Core Pointer and Keyboard in
    XInput 2), but calling this function on any slave devices (i.e.
    those managed via XInput 1.x), will return 0.

Since: 3.2

## x11DeviceManagerLookup

x11DeviceManagerLookup Source #

Arguments

:: (HasCallStack, MonadIO m, IsX11DeviceManagerCore a) |
=> a | `deviceManager`: a `DeviceManager`
-> Int32 | `deviceId`: a device ID, as understood by the XInput2 protocol
-> m (Maybe X11DeviceCore) | Returns: The `Device` wrapping the device ID, or `Nothing` if the given ID doesn’t currently represent a device.

Returns the `Device` that wraps the given device ID.

Since: 3.2

## x11FreeCompoundText

x11FreeCompoundText Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Word8 | `ctext`: The pointer stored in `ctext` from a call to `x11DisplayStringToCompoundText`.
-> m () |

Frees the data returned from `x11DisplayStringToCompoundText`.

Since: 2.24

## x11FreeTextList

x11FreeTextList Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Text | `list`: the value stored in the `list` parameter by a call to `x11DisplayTextPropertyToTextList`.
-> m () |

Frees the array of strings created by `x11DisplayTextPropertyToTextList`.

Since: 2.24

## x11GetDefaultRootXwindow

x11GetDefaultRootXwindow Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> m CULong | Returns: an Xlib Window.

Gets the root window of the default screen (see `x11GetDefaultScreen`).

## x11GetDefaultScreen

x11GetDefaultScreen Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> m Int32 | Returns: returns the screen number specified by the --display command line option or the DISPLAY environment variable when `init` calls `openDisplay`.

Gets the default GTK+ screen number.

## x11GetDefaultXdisplay

x11GetDefaultXdisplay Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> m Display | Returns: the Xlib Display* for the display specified in the `--display` command line option or the `DISPLAY` environment variable.

Gets the default GTK+ display.

## x11GetParentRelativePattern

x11GetParentRelativePattern :: (HasCallStack, MonadIO m) => m Pattern Source #

Deprecated: (Since version 3.24)Don't use this function

Used with `windowSetBackgroundPattern` to inherit background from parent window. Useful for imitating transparency when compositing is not available. Otherwise behaves like a transparent pattern.

Since: 3.24.2

## x11GetServerTime

x11GetServerTime Source #

Arguments

:: (HasCallStack, MonadIO m, IsX11Window a) |
=> a | `window`: a `Window`, used for communication with the server. The window must have GDK_PROPERTY_CHANGE_MASK in its events mask or a hang will result.
-> m Word32 | Returns: the time stamp.

Routine to get the current X server time stamp.

## x11GetXatomByName

x11GetXatomByName Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Text | `atomName`: a string
-> m CULong | Returns: a X atom for GDK’s default display.

Returns the X atom for GDK’s default display corresponding to `atomName`. This function caches the result, so if called repeatedly it is much faster than `XInternAtom()`, which is a round trip to the server each time.

## x11GetXatomByNameForDisplay

x11GetXatomByNameForDisplay Source #

Arguments

:: (HasCallStack, MonadIO m, IsX11Display a) |
=> a | `display`: a `Display`
-> Text | `atomName`: a string
-> m CULong | Returns: a X atom for a `Display`

Returns the X atom for a `Display` corresponding to `atomName`. This function caches the result, so if called repeatedly it is much faster than `XInternAtom()`, which is a round trip to the server each time.

Since: 2.2

## x11GetXatomName

x11GetXatomName Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> CULong | `xatom`: an X atom for GDK’s default display
-> m Text | Returns: name of the X atom; this string is owned by GTK+, so it shouldn’t be modifed or freed.

Returns the name of an X atom for GDK’s default display. This function is meant mainly for debugging, so for convenience, unlike `XAtomName()` and `atomName`, the result doesn’t need to be freed. Also, this function will never return `Nothing`, even if `xatom` is invalid.

## x11GetXatomNameForDisplay

x11GetXatomNameForDisplay Source #

Arguments

:: (HasCallStack, MonadIO m, IsX11Display a) |
=> a | `display`: the `Display` where `xatom` is defined
-> CULong | `xatom`: an X atom
-> m Text | Returns: name of the X atom; this string is owned by GDK, so it shouldn’t be modifed or freed.

Returns the name of an X atom for its display. This function is meant mainly for debugging, so for convenience, unlike `XAtomName()` and `atomName`, the result doesn’t need to be freed.

Since: 2.2

## x11GrabServer

x11GrabServer :: (HasCallStack, MonadIO m) => m () Source #

Call `x11DisplayGrab` on the default display. To ungrab the server again, use `x11UngrabServer`.

`x11GrabServer`/`x11UngrabServer` calls can be nested.

## x11LookupXdisplay

x11LookupXdisplay Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Display | `xdisplay`: a pointer to an X Display
-> m X11Display | Returns: the `Display`, if found, otherwise `Nothing`.

Find the `Display` corresponding to `xdisplay`, if any exists.

Since: 2.2

## x11RegisterStandardEventType

x11RegisterStandardEventType Source #

Arguments

:: (HasCallStack, MonadIO m, IsX11Display a) |
=> a | `display`: a `Display`
-> Int32 | `eventBase`: first event type code to register
-> Int32 | `nEvents`: number of event type codes to register
-> m () |

Registers interest in receiving extension events with type codes between `eventBase` and `event_base + n_events - 1`. The registered events must have the window field in the same place as core X events (this is not the case for e.g. XKB extension events).

If an event type is registered, events of this type will go through global and window-specific filters (see `gdk_window_add_filter()`). Unregistered events will only go through global filters. GDK may register the events of some X extensions on its own.

This function should only be needed in unusual circumstances, e.g. when filtering XInput extension events on the root window.

Since: 2.4

## x11SetSmClientId

x11SetSmClientId Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Maybe Text | `smClientId`: the client id assigned by the session manager when the connection was opened, or `Nothing` to remove the property.
-> m () |

Sets the `SM_CLIENT_ID` property on the application’s leader window so that the window manager can save the application’s state using the X11R6 ICCCM session management protocol.

See the X Session Management Library documentation for more information on session management and the Inter-Client Communication Conventions Manual

Since: 2.24

## x11UngrabServer

x11UngrabServer :: (HasCallStack, MonadIO m) => m () Source #

Ungrab the default display after it has been grabbed with `x11GrabServer`.

## x11XatomToAtom

x11XatomToAtom Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> CULong | `xatom`: an X atom for the default GDK display
-> m Atom | Returns: the corresponding G`dkAtom`.

Convert from an X atom for the default display to the corresponding `Atom`.

## x11XatomToAtomForDisplay

x11XatomToAtomForDisplay Source #

Arguments

:: (HasCallStack, MonadIO m, IsX11Display a) |
=> a | `display`: A `Display`
-> CULong | `xatom`: an X atom
-> m Atom | Returns: the corresponding `Atom`.

Convert from an X atom for a `Display` to the corresponding `Atom`.

Since: 2.2